/** @file depend.h

	Skelton for retropc emulator


	@author Sasaji
	@date   2012.03.01

	@brief [ dependency definition ]
*/

#ifndef _DEPEND_H_
#define _DEPEND_H_

// check memory leaks
#if defined(_DEBUG) && defined(_WIN32) && !defined(__MINGW32__)
//#define _CRTDBG_MAP_ALLOC
#undef _malloca
#include <stdlib.h>
#include <crtdbg.h>
#define malloc(s) _malloc_dbg(s, _NORMAL_BLOCK, __FILE__, __LINE__)
#if _MSC_VER > 1500
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
#endif

#include <SDL.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef _WIN32
/* windows */
#include <windows.h>
#include <tchar.h>

#ifdef __MINGW32__
#include <getopt.h>
#endif

#else
/* linux, macosx */
#include <unistd.h>
#include "extra/tchar.h"

#define __stdcall

#endif

#ifndef _MAX_PATH
#define _MAX_PATH	(260)
#endif

#ifdef _UNICODE
	/* _UNICODE */

//#define MBSTOWCS(dst, src, len) mbstowcs(dst, src, len)
//#define WCSTOMBS(dst, src, len) wcstombs(dst, src, len)

#ifndef _WIN32
wchar_t *_wgetenv(const wchar_t *);
int _wsystem(const wchar_t *);
int swprintf(wchar_t *ws, const wchar_t *format, ...);
int vswprintf(wchar_t *ws, const wchar_t *format, va_list arg);
#endif

#else	/* !_UNICODE */

//#define MBSTOWCS(dst, src, len) strncpy(dst, src, len)
//#define WCSTOMBS(dst, src, len) strncpy(dst, src, len)

#endif	/* _UNICODE */

#endif	/* _DEPEND_H_ */
