/** @file ledbox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.03.08 -

	@brief [ led box ]
*/

#ifndef _LEDBOX_H_
#define _LEDBOX_H_

#include "vm/vm.h"
#include <SDL.h>

/**
	@brief LedBox is the class that display the access indicator on the screen.
*/
class LedBox
{
private:
	SDL_Surface *surface;

	SDL_Surface *suf_base;

	SDL_Surface *suf_kata;
	SDL_Surface *suf_hira;
	SDL_Surface *suf_caps;

	SDL_Surface *suf_play;
	SDL_Surface *suf_rec;

	SDL_Surface *suf_digit10;

	SDL_Rect pt_kata;
	SDL_Rect pt_hira;
	SDL_Rect pt_caps;

	SDL_Rect pt_play;
	SDL_Rect pt_rec;

	SDL_Rect pt_digit1;
	SDL_Rect pt_digit2;
	SDL_Rect pt_digit3;

	int flag_old;

#ifdef USE_FD1
	SDL_Surface *suf_fddr;
	SDL_Surface *suf_fddg;

	SDL_Rect pt_fdd1;
	SDL_Rect pt_fdd2;
#endif

	struct win_pt_st {
		int left;
		int top;
		int right;
		int bottom;
		int place;
	} win_pt;

	SDL_Rect parent_pt;

public:
	LedBox();
	~LedBox();

	bool Create(char *, SDL_PixelFormat *);
	bool CreateSurface(SDL_PixelFormat *);
	void SetPos(int, int, int, int, int);
	void SetPos(int);
	void MixScreen(SDL_Surface *, int, int);
	void MixScreen(SDL_Surface *);
	void Update(SDL_Surface *screen, int, int, int);
	void Update(SDL_Surface *screen, int);
};

#endif /* _LEDBOX_H_ */

