/** @file board.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.06.21 -

	@brief [ main board ]
*/

#include "board.h"

void BOARD::write_signal(int id, uint32 data, uint32 mask)
{
	switch (id) {
		case SIG_CPU_RESET:
			write_signals(&outputs_reset, (data & mask) ? 0xffffffff : 0);
//			if ((data & mask) == 0) {
//				emu->out_info(_T("Reset"));
//			}
			break;
	}
}

// ----------------------------------------------------------------------------

void BOARD::save_state(FILEIO *fio)
{
	struct vm_state_st vm_state;

	//
	vm_state_ident.version = 1;
	vm_state_ident.size = sizeof(vm_state_ident) + sizeof(vm_state);

	// save config flags
	memset(&vm_state, 0, sizeof(vm_state));
	vm_state.fdd_type = emu->get_parami(EMU::ParamFddType);
	vm_state.io_port = emu->get_parami(EMU::ParamIOPort);
	vm_state.flags = ((config.sync_irq ? 1 : 0) | (config.realmode_datarec ? 2 : 0));

	fio->Fwrite(&vm_state_ident, sizeof(vm_state_ident), 1);
	fio->Fwrite(&vm_state, sizeof(vm_state), 1);
}

void BOARD::load_state(FILEIO *fio)
{
	vm_state_ident_t vm_state_i;
	struct vm_state_st vm_state;

	READ_STATE_CHUNK(fio, vm_state_i, vm_state);

	// load config flags
	emu->set_parami(EMU::ParamFddType, vm_state.fdd_type);
	emu->set_parami(EMU::ParamIOPort, vm_state.io_port);
	config.sync_irq = ((vm_state.flags & 1) ? true : false);
	config.realmode_datarec = ((vm_state.flags & 2) ? true : false);
}

